<html>
<head>
<title>Ogre::StringInterface Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1StringInterface.html">StringInterface</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="#pri-static-attribs">Static Private Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::StringInterface Class Reference<div class="ingroups"><a class="el" href="group__General.html">General</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::StringInterface" -->
<p>Class defining the common interface which classes can use to present a reflection-style, self-defining parameter set to callers.  
 <a href="classOgre_1_1StringInterface.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreStringInterface_8h_source.html">OgreStringInterface.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::StringInterface:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1StringInterface__inherit__graph.gif" border="0" usemap="#Ogre_1_1StringInterface_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1StringInterface_inherit__map" id="Ogre_1_1StringInterface_inherit__map">
<area shape="rect" id="node3" href="classOgre_1_1ExternalTextureSource.html" title="IMPORTANT: **Plugins must override default dictionary name!** Base class that texture plugins derive ..." alt="" coords="203,5,392,35"/><area shape="rect" id="node5" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay." alt="" coords="223,59,372,88"/><area shape="rect" id="node13" href="classOgre_1_1ParticleAffector.html" title="Abstract class defining the interface to be implemented by particle affectors." alt="" coords="224,112,371,141"/><area shape="rect" id="node15" href="classOgre_1_1ParticleEmitter.html" title="Abstract class defining the interface to be implemented by particle emitters." alt="" coords="225,165,369,195"/><area shape="rect" id="node17" href="classOgre_1_1ParticleSystem.html" title="Class defining particle system based special effects." alt="" coords="224,219,371,248"/><area shape="rect" id="node19" href="classOgre_1_1ParticleSystemRenderer.html" title="Abstract class defining the interface required to be implemented by classes which provide rendering c..." alt="" coords="197,272,397,301"/><area shape="rect" id="node23" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g." alt="" coords="240,405,355,435"/><area shape="rect" id="node7" href="classOgre_1_1OverlayContainer.html" title="A 2D element which contains other OverlayElement instances." alt="" coords="469,32,627,61"/><area shape="rect" id="node11" href="classOgre_1_1TextAreaOverlayElement.html" title="This class implements an overlay element which contains simple unformatted text." alt="" coords="447,85,649,115"/><area shape="rect" id="node9" href="classOgre_1_1PanelOverlayElement.html" title="OverlayElement representing a flat, single&#45;material (or transparent) panel which can contain other el..." alt="" coords="701,32,885,61"/><area shape="rect" id="node21" href="classOgre_1_1BillboardParticleRenderer.html" title="Specialisation of ParticleSystemRenderer to render particles using a BillboardSet." alt="" coords="445,219,651,248"/><area shape="rect" id="node25" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object." alt="" coords="485,272,611,301"/><area shape="rect" id="node27" href="classOgre_1_1Font.html" title="Class representing a font in the system." alt="" coords="507,325,589,355"/><area shape="rect" id="node29" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program." alt="" coords="483,379,613,408"/><area shape="rect" id="node41" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object." alt="" coords="496,432,600,461"/><area shape="rect" id="node43" href="classOgre_1_1Mesh.html" title="Ogre::Mesh" alt="" coords="503,485,593,515"/><area shape="rect" id="node47" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh." alt="" coords="493,539,603,568"/><area shape="rect" id="node51" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource." alt="" coords="497,672,599,701"/><area shape="rect" id="node31" href="classOgre_1_1D3D11GpuProgram.html" title="Direct3D implementation of a few things common to low&#45;level vertex &amp; fragment programs." alt="" coords="708,219,879,248"/><area shape="rect" id="node33" href="classOgre_1_1D3D9GpuProgram.html" title="Direct3D implementation of a few things common to low&#45;level vertex &amp; fragment programs." alt="" coords="711,272,876,301"/><area shape="rect" id="node35" href="classOgre_1_1GLES2GpuProgram.html" title="Generalised low&#45;level GL program, can be applied to multiple types (eg ARB and NV)" alt="" coords="707,325,880,355"/><area shape="rect" id="node37" href="classOgre_1_1GLGpuProgram.html" title="Generalised low&#45;level GL program, can be applied to multiple types (eg ARB and NV)" alt="" coords="720,379,867,408"/><area shape="rect" id="node39" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high&#45;level program (a vertex or fragment program)." alt="" coords="699,432,888,461"/><area shape="rect" id="node45" href="classOgre_1_1PatchMesh.html" title="Patch specialisation of Mesh." alt="" coords="732,485,855,515"/><area shape="rect" id="node49" href="classOgre_1_1SkeletonInstance.html" title="A SkeletonInstance is a single instance of a Skeleton used by a world object." alt="" coords="715,539,872,568"/><area shape="rect" id="node53" href="classOgre_1_1D3D11Texture.html" title="Ogre::D3D11Texture" alt="" coords="723,592,864,621"/><area shape="rect" id="node55" href="classOgre_1_1D3D9Texture.html" title="Ogre::D3D9Texture" alt="" coords="725,645,861,675"/><area shape="rect" id="node57" href="classOgre_1_1GLES2Texture.html" title="Ogre::GLES2Texture" alt="" coords="721,699,865,728"/><area shape="rect" id="node59" href="classOgre_1_1GLESTexture.html" title="Ogre::GLESTexture" alt="" coords="725,752,861,781"/><area shape="rect" id="node61" href="classOgre_1_1GLTexture.html" title="Ogre::GLTexture" alt="" coords="735,805,852,835"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1StringInterface-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringInterface.html#ad57e8c6f0793dde7d1b479361e55e419">StringInterface</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringInterface.html#aa86a8941e57b203088797a4b28da8c4d">~StringInterface</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Virtual destructor, see Effective C++.  <a href="#aa86a8941e57b203088797a4b28da8c4d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1ParamDictionary.html">ParamDictionary</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringInterface.html#ae3e13925bde11db245f6c9bbf5031a93">getParamDictionary</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieves the parameter dictionary for this class.  <a href="#ae3e13925bde11db245f6c9bbf5031a93"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classOgre_1_1ParamDictionary.html">ParamDictionary</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringInterface.html#a3bfa7791753a155b222dfb2706e5218c">getParamDictionary</a> (void) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="group__General.html#gac3c212f18e4a3e6aba496571cfbe5400">ParameterList</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringInterface.html#adfedfcc90e1d602ec6fa646d4d90f17f">getParameters</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieves a list of parameters valid for this object.  <a href="#adfedfcc90e1d602ec6fa646d4d90f17f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringInterface.html#ace884b65b722ead9b920b9abf27bf815">setParameter</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;value)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Generic parameter setting method.  <a href="#ace884b65b722ead9b920b9abf27bf815"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringInterface.html#ae356913ccefbebc4f0119a0599a406fc">setParameterList</a> (const <a class="el" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19">NameValuePairList</a> &amp;paramList)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Generic multiple parameter setting method.  <a href="#ae356913ccefbebc4f0119a0599a406fc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringInterface.html#a57397ce47f649e66c5654da05207df0b">getParameter</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Generic parameter retrieval method.  <a href="#a57397ce47f649e66c5654da05207df0b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringInterface.html#a702af78cbc4869e64c369fb11c4f1eb5">copyParametersTo</a> (<a class="el" href="classOgre_1_1StringInterface.html">StringInterface</a> *dest) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Method for copying this object's parameters to another object.  <a href="#a702af78cbc4869e64c369fb11c4f1eb5"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringInterface.html#a1bea65fa2b3c2ac5a9f3be59b46a80e8">cleanupDictionary</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Cleans up the static 'msDictionary' required to reset <a class="el" href="namespaceOgre.html">Ogre</a>, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the <a class="el" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a> implementers (e.g.  <a href="#a1bea65fa2b3c2ac5a9f3be59b46a80e8"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringInterface.html#a681773443d95aea05a486c5d22c15bd1">createParamDictionary</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;className)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal method for creating a parameter dictionary for the class, if it does not already exist.  <a href="#a681773443d95aea05a486c5d22c15bd1"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringInterface.html#abaa2b2c02f22cff7a65ba43b4daea538">mParamDictName</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class name for this instance to be used as a lookup (must be initialised by subclasses)  <a href="#abaa2b2c02f22cff7a65ba43b4daea538"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1ParamDictionary.html">ParamDictionary</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringInterface.html#a3f3117095c1bff9d46177279d3fb79ea">mParamDict</a></td></tr>
<tr><td colspan="2"><h2><a name="pri-static-attribs"></a>
Static Private Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="group__General.html#gadb243c5b21d57e9c053b067801f47780">ParamDictionaryMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StringInterface.html#a5e08eb863343f9c60f6ef9344a48075b">msDictionary</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Dictionary of parameters.  <a href="#a5e08eb863343f9c60f6ef9344a48075b"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Class defining the common interface which classes can use to present a reflection-style, self-defining parameter set to callers. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This class also holds a static map of class name to parameter dictionaries for each subclass to use. See <a class="el" href="classOgre_1_1ParamDictionary.html" title="Class to hold a dictionary of parameters for a single class.">ParamDictionary</a> for details. </dd>
<dd>
In order to use this class, each subclass must call createParamDictionary in their constructors which will create a parameter dictionary for the class if it does not exist yet. </dd></dl>

<p>Definition at line <a class="el" href="OgreStringInterface_8h_source.html#l00161">161</a> of file <a class="el" href="OgreStringInterface_8h_source.html">OgreStringInterface.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ad57e8c6f0793dde7d1b479361e55e419"></a><!-- doxytag: member="Ogre::StringInterface::StringInterface" ref="ad57e8c6f0793dde7d1b479361e55e419" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1StringInterface.html#ad57e8c6f0793dde7d1b479361e55e419">Ogre::StringInterface::StringInterface</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreStringInterface_8h_source.html#l00205">205</a> of file <a class="el" href="OgreStringInterface_8h_source.html">OgreStringInterface.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa86a8941e57b203088797a4b28da8c4d"></a><!-- doxytag: member="Ogre::StringInterface::~StringInterface" ref="aa86a8941e57b203088797a4b28da8c4d" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1StringInterface.html#aa86a8941e57b203088797a4b28da8c4d">Ogre::StringInterface::~StringInterface</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Virtual destructor, see Effective C++. </p>

<p>Definition at line <a class="el" href="OgreStringInterface_8h_source.html#l00208">208</a> of file <a class="el" href="OgreStringInterface_8h_source.html">OgreStringInterface.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a1bea65fa2b3c2ac5a9f3be59b46a80e8"></a><!-- doxytag: member="Ogre::StringInterface::cleanupDictionary" ref="a1bea65fa2b3c2ac5a9f3be59b46a80e8" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void <a class="el" href="classOgre_1_1StringInterface.html#a1bea65fa2b3c2ac5a9f3be59b46a80e8">Ogre::StringInterface::cleanupDictionary</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Cleans up the static 'msDictionary' required to reset <a class="el" href="namespaceOgre.html">Ogre</a>, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the <a class="el" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a> implementers (e.g. </p>
<p><a class="el" href="classOgre_1_1MaterialManager.html" title="Class for managing Material settings for Ogre.">MaterialManager</a>) initializes. </p>

</div>
</div>
<a class="anchor" id="a702af78cbc4869e64c369fb11c4f1eb5"></a><!-- doxytag: member="Ogre::StringInterface::copyParametersTo" ref="a702af78cbc4869e64c369fb11c4f1eb5" args="(StringInterface *dest) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1StringInterface.html#a702af78cbc4869e64c369fb11c4f1eb5">Ogre::StringInterface::copyParametersTo</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StringInterface.html">StringInterface</a> *&#160;</td>
          <td class="paramname"><em>dest</em></td><td>)</td>
          <td> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Method for copying this object's parameters to another object. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop. </dd></dl>
<dl class="user"><dt><b></b></dt><dd><a class="el" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> unrecognised parameters will be ignored as with setParameter method. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">dest</td><td>Pointer to object to have it's parameters set the same as this object. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="OgreStringInterface_8h_source.html#l00301">301</a> of file <a class="el" href="OgreStringInterface_8h_source.html">OgreStringInterface.h</a>.</p>

<p>References <a class="el" href="OgreStringInterface_8h_source.html#l00093">Ogre::ParamDictionary::mParamDefs</a>, and <a class="el" href="classOgre_1_1StringInterface.html#ace884b65b722ead9b920b9abf27bf815">setParameter()</a>.</p>

</div>
</div>
<a class="anchor" id="a681773443d95aea05a486c5d22c15bd1"></a><!-- doxytag: member="Ogre::StringInterface::createParamDictionary" ref="a681773443d95aea05a486c5d22c15bd1" args="(const String &amp;className)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1StringInterface.html#a681773443d95aea05a486c5d22c15bd1">Ogre::StringInterface::createParamDictionary</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>className</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal method for creating a parameter dictionary for the class, if it does not already exist. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance). </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">className</td><td>the name of the class using the dictionary </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>true if a new dictionary was created, false if it was already there </dd></dl>

<p>Definition at line <a class="el" href="OgreStringInterface_8h_source.html#l00184">184</a> of file <a class="el" href="OgreStringInterface_8h_source.html">OgreStringInterface.h</a>.</p>

<p>References <a class="el" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>.</p>

</div>
</div>
<a class="anchor" id="ae3e13925bde11db245f6c9bbf5031a93"></a><!-- doxytag: member="Ogre::StringInterface::getParamDictionary" ref="ae3e13925bde11db245f6c9bbf5031a93" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ParamDictionary.html">ParamDictionary</a>* <a class="el" href="classOgre_1_1StringInterface.html#ae3e13925bde11db245f6c9bbf5031a93">Ogre::StringInterface::getParamDictionary</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Retrieves the parameter dictionary for this class. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Only valid to call this after createParamDictionary. </dd></dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>Pointer to <a class="el" href="classOgre_1_1ParamDictionary.html" title="Class to hold a dictionary of parameters for a single class.">ParamDictionary</a> shared by all instances of this class which you can add parameters to, retrieve parameters etc. </dd></dl>

<p>Definition at line <a class="el" href="OgreStringInterface_8h_source.html#l00217">217</a> of file <a class="el" href="OgreStringInterface_8h_source.html">OgreStringInterface.h</a>.</p>

</div>
</div>
<a class="anchor" id="a3bfa7791753a155b222dfb2706e5218c"></a><!-- doxytag: member="Ogre::StringInterface::getParamDictionary" ref="a3bfa7791753a155b222dfb2706e5218c" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1ParamDictionary.html">ParamDictionary</a>* <a class="el" href="classOgre_1_1StringInterface.html#ae3e13925bde11db245f6c9bbf5031a93">Ogre::StringInterface::getParamDictionary</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreStringInterface_8h_source.html#l00222">222</a> of file <a class="el" href="OgreStringInterface_8h_source.html">OgreStringInterface.h</a>.</p>

</div>
</div>
<a class="anchor" id="a57397ce47f649e66c5654da05207df0b"></a><!-- doxytag: member="Ogre::StringInterface::getParameter" ref="a57397ce47f649e66c5654da05207df0b" args="(const String &amp;name) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1StringInterface.html#a57397ce47f649e66c5654da05207df0b">Ogre::StringInterface::getParameter</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Generic parameter retrieval method. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use <a class="el" href="classOgre_1_1StringConverter.html" title="Class for converting the core Ogre data types to/from Strings.">StringConverter</a> to convert this string back into a native type. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>The name of the parameter to get </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>String value of parameter, blank if not found </dd></dl>

<p>Definition at line <a class="el" href="OgreStringInterface_8h_source.html#l00270">270</a> of file <a class="el" href="OgreStringInterface_8h_source.html">OgreStringInterface.h</a>.</p>

<p>References <a class="el" href="classOgre_1_1ParamCommand.html#ae47ea550693403baebbcde11c59e074f">Ogre::ParamCommand::doGet()</a>, and <a class="el" href="OgreStringInterface_8h_source.html#l00099">Ogre::ParamDictionary::getParamCommand()</a>.</p>

</div>
</div>
<a class="anchor" id="adfedfcc90e1d602ec6fa646d4d90f17f"></a><!-- doxytag: member="Ogre::StringInterface::getParameters" ref="adfedfcc90e1d602ec6fa646d4d90f17f" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="group__General.html#gac3c212f18e4a3e6aba496571cfbe5400">ParameterList</a>&amp; <a class="el" href="classOgre_1_1StringInterface.html#adfedfcc90e1d602ec6fa646d4d90f17f">Ogre::StringInterface::getParameters</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Retrieves a list of parameters valid for this object. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>A reference to a static list of <a class="el" href="classOgre_1_1ParameterDef.html" title="Definition of a parameter supported by a StringInterface class, for introspection.">ParameterDef</a> objects. </dd></dl>

</div>
</div>
<a class="anchor" id="ace884b65b722ead9b920b9abf27bf815"></a><!-- doxytag: member="Ogre::StringInterface::setParameter" ref="ace884b65b722ead9b920b9abf27bf815" args="(const String &amp;name, const String &amp;value)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1StringInterface.html#ace884b65b722ead9b920b9abf27bf815">Ogre::StringInterface::setParameter</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Generic parameter setting method. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from <a class="el" href="classOgre_1_1StringInterface.html#adfedfcc90e1d602ec6fa646d4d90f17f" title="Retrieves a list of parameters valid for this object.">StringInterface::getParameters</a>. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>The name of the parameter to set </td></tr>
    <tr><td class="paramname">value</td><td>String value. Must be in the right format for the type specified in the parameter definition. See the <a class="el" href="classOgre_1_1StringConverter.html" title="Class for converting the core Ogre data types to/from Strings.">StringConverter</a> class for more information. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>true if set was successful, false otherwise (NB no exceptions thrown - tolerant method) </dd></dl>

<p>Referenced by <a class="el" href="OgreStringInterface_8h_source.html#l00301">copyParametersTo()</a>.</p>

</div>
</div>
<a class="anchor" id="ae356913ccefbebc4f0119a0599a406fc"></a><!-- doxytag: member="Ogre::StringInterface::setParameterList" ref="ae356913ccefbebc4f0119a0599a406fc" args="(const NameValuePairList &amp;paramList)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1StringInterface.html#ae356913ccefbebc4f0119a0599a406fc">Ogre::StringInterface::setParameterList</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19">NameValuePairList</a> &amp;&#160;</td>
          <td class="paramname"><em>paramList</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Generic multiple parameter setting method. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from <a class="el" href="classOgre_1_1StringInterface.html#adfedfcc90e1d602ec6fa646d4d90f17f" title="Retrieves a list of parameters valid for this object.">StringInterface::getParameters</a>. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">paramList</td><td>Name/value pair list </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a3f3117095c1bff9d46177279d3fb79ea"></a><!-- doxytag: member="Ogre::StringInterface::mParamDict" ref="a3f3117095c1bff9d46177279d3fb79ea" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ParamDictionary.html">ParamDictionary</a>* <a class="el" href="classOgre_1_1StringInterface.html#a3f3117095c1bff9d46177279d3fb79ea">Ogre::StringInterface::mParamDict</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreStringInterface_8h_source.html#l00171">171</a> of file <a class="el" href="OgreStringInterface_8h_source.html">OgreStringInterface.h</a>.</p>

</div>
</div>
<a class="anchor" id="abaa2b2c02f22cff7a65ba43b4daea538"></a><!-- doxytag: member="Ogre::StringInterface::mParamDictName" ref="abaa2b2c02f22cff7a65ba43b4daea538" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1StringInterface.html#abaa2b2c02f22cff7a65ba43b4daea538">Ogre::StringInterface::mParamDictName</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class name for this instance to be used as a lookup (must be initialised by subclasses) </p>

<p>Definition at line <a class="el" href="OgreStringInterface_8h_source.html#l00170">170</a> of file <a class="el" href="OgreStringInterface_8h_source.html">OgreStringInterface.h</a>.</p>

</div>
</div>
<a class="anchor" id="a5e08eb863343f9c60f6ef9344a48075b"></a><!-- doxytag: member="Ogre::StringInterface::msDictionary" ref="a5e08eb863343f9c60f6ef9344a48075b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__General.html#gadb243c5b21d57e9c053b067801f47780">ParamDictionaryMap</a> <a class="el" href="classOgre_1_1StringInterface.html#a5e08eb863343f9c60f6ef9344a48075b">Ogre::StringInterface::msDictionary</a><code> [static, private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Dictionary of parameters. </p>

<p>Definition at line <a class="el" href="OgreStringInterface_8h_source.html#l00167">167</a> of file <a class="el" href="OgreStringInterface_8h_source.html">OgreStringInterface.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreStringInterface_8h_source.html">OgreStringInterface.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:08
</p>
</body>
</html>
